SecondMVCAppMy/Models/Topics/TopicFilterAndSortModel.cs
using System;
using System.Collections.Generic;
using System.ComponentModel.DataAnnotations;
using SecondMVCAppMy.Models.PostInTopics;

namespace SecondMVCAppMy.Models.Topics
{
    public class TopicFilterAndSortModel
    {
        [Display(Name = "По автору темы")]
        public string Author { get; set; }

        [Display(Name = "По ключевому слову")]
        public string SearchKey { get; set; }

        [Display(Name = "Дата от")]
        public DateTime? DateFrom { get; set; }

        [Display(Name = "Дата до")]
        public DateTime? DateTo { get; set; }
        
        public TopicModel TopicModel { get; set; }

        public List<TopicModel> Topics { get; set; }
        
        public TopicSortState DateOfCreationSort { get; set; }

        public TopicSortState AuthorSort { get; set; }
        
        public TopicSortState TopicTitleSort { get; set; }
        
        public TopicSortState TopicContentSort { get; set; }
        
        public TopicSortState TopicSortState { get; set; }
        
        public int? Page { get; set; }
        
        public TopicPageModel TopicPageModel { get; set; }

        public PostInTopicModel PostInTopicModel { get; set; }

        public List<PostInTopicModel> PostInTopics { get; set; }
    }
}

SecondMVCAppMy/Models/Topics/TopicModel.cs
using System.ComponentModel.DataAnnotations;

namespace SecondMVCAppMy.Models.Topics
{
    public class TopicModel
    {
        public int Id { get; set; }

        [Display(Name = "Дата создания темы")]
        public string DateOfCreation { get; set; }

        public int AuthorId { get; set; }

        [Display(Name = "Автор темы")]
        public string Author { get; set; }

        [Display(Name = "Заголовок темы")]
        public string TopicTitle { get; set; }

        [Display(Name = "Заголовок темы")]
        public string TopicContent { get; set; }

        [Display(Name = "Кол-во сообщений")]
        public int PostsQty { get; set; }

        [Display(Name = "Кол-во Ваших сообщений")]
        public int QtyUserPostsInTopic { get; set; }

        [Display(Name = "Лайки")]
        public int Likes { get; set; }

        [Display(Name = "Дизлайки")]
        public int Dislikes { get; set; }
    }
}

SecondMVCAppMy/Models/Topics/TopicPageModel.cs
using System;

namespace SecondMVCAppMy.Models.Topics
{
    public class TopicPageModel
    {
        public int PageNumber { get; set; }
        public int TotalPages { get; set; }

        public TopicPageModel(int count, int pageNumber, int pageSize)
        {
            PageNumber = pageNumber;
            TotalPages = (int)Math.Ceiling(count / (double)pageSize);
        }

        public bool HasPreviousPage => PageNumber > 1;

        public bool HasNextPage => PageNumber < TotalPages;
    }
}

SecondMVCAppMy/Models/Topics/TopicRequestModel.cs
using System.ComponentModel.DataAnnotations;
using Newtonsoft.Json;

namespace SecondMVCAppMy.Models.Topics
{
    public class TopicRequestModel
    {
        [Required]
        [JsonProperty(propertyName: "topicTitle")]
        [Display(Name = "Заголовок темы")]
        public string TopicTitle { get; set; }

        [Required]
        [JsonProperty(propertyName: "topicContent")]
        public string TopicContent { get; set; }
    }
}

SecondMVCAppMy/Models/Topics/TopicSortState.cs
namespace SecondMVCAppMy.Models.Topics
{
    public enum TopicSortState
    {
        DateOfCreationAsc,
        DateOfCreationDesc,
        AuthorAsc,
        AuthorDesc,
        TopicTitleAsc,
        TopicTitleDesc,
        TopicContentAsc,
        TopicContentDesc
    }
}

SecondMVCAppMy/Controllers/PostInTopicController.cs
using System;
using System.Threading.Tasks;
using Microsoft.AspNetCore.Authorization;
using Microsoft.AspNetCore.Identity;
using Microsoft.AspNetCore.Mvc;
using SecondMVCAppMy.DAL.Entities;
using SecondMVCAppMy.Models.PostInTopics;
using SecondMVCAppMy.Services.PostInTopics.Contracts;

namespace SecondMVCAppMy.Controllers
{
    public class PostInTopicController : Controller
    {
        private readonly IPostInTopicService _postInTopicService;
        private readonly UserManager<User> _userManager;

        public PostInTopicController(IPostInTopicService postInTopicService, UserManager<User> userManager)
        {
            if (postInTopicService == null)
                throw new ArgumentNullException(nameof(postInTopicService));
            if (userManager == null)
                throw new ArgumentNullException(nameof(userManager));

            _postInTopicService = postInTopicService;
            _userManager = userManager;
        }

        [Authorize]
        [HttpGet]
        public IActionResult Index(int? topicId, PostInTopicSortAndPageModel model, PostInTopicSortState sortState = PostInTopicSortState.DateOfPublicationAsc)
        {
            if (!topicId.HasValue)
                throw new ArgumentOutOfRangeException(nameof(topicId));
            try
            {
                var postInTopics = _postInTopicService.GetPostInTopicSortPageModel(topicId.Value, model, sortState);
                return View(postInTopics);
            }
            catch (ArgumentOutOfRangeException ex)
            {
                ViewBag.BadRequestMessage = ex.Message;
                return View("BadRequest");
            }
            catch (Exception ex)
            {
                return StatusCode(500, ex.Message);
            }
        }

        [Authorize]
        [HttpPost]
        public IActionResult LikeForPostInTopic(int? postInTopicId)
        {
            if (!postInTopicId.HasValue)
                throw new ArgumentOutOfRangeException(nameof(postInTopicId));
            try
            {
                var likes = _postInTopicService.GetLikeForPostInTopic(postInTopicId.Value);
                return Ok(likes);
            }
            catch (Exception ex)
            {
                return StatusCode(500, ex.Message);
            }
        }

        [Authorize]
        [HttpPost]
        public IActionResult DisLikeForPostInTopic(int? postInTopicId)
        {

            if (!postInTopicId.HasValue)
                throw new ArgumentOutOfRangeException(nameof(postInTopicId));
            try
            {
                var dislikes = _postInTopicService.GetDislikeForPostInTopic(postInTopicId.Value);
                return Ok(dislikes);
            }
            catch (Exception ex)
            {
                return StatusCode(500, ex.Message);
            }
        }

        [Authorize]
        [HttpPost]
        public async Task<IActionResult> CreatePostInTopicAjax(PostInTopicRequestModel model)
        {
            try
            {
                User currentUser = await _userManager.GetUserAsync(User);
                var postInTopicModel = _postInTopicService.CreatePostInTopicAjax(model, currentUser);
                
                return Ok(postInTopicModel);
            }
            catch (Exception ex)
            {
                return StatusCode(500, ex.Message);
            }
        }
    }
}

SecondMVCAppMy/Controllers/TopicController.cs
using System;
using System.Threading.Tasks;
using Microsoft.AspNetCore.Authorization;
using Microsoft.AspNetCore.Identity;
using Microsoft.AspNetCore.Mvc;
using SecondMVCAppMy.DAL.Entities;
using SecondMVCAppMy.Models.Topics;
using SecondMVCAppMy.Services.Topics.Contracts;

namespace SecondMVCAppMy.Controllers
{
    public class TopicController : Controller
    {
        private readonly ITopicService _topicService;
        private readonly UserManager<User> _userManager;

        public TopicController(ITopicService topicService, UserManager<User> userManager)
        {
            if (topicService == null)
                throw new ArgumentNullException(nameof(topicService));
            if (userManager == null)
                throw new ArgumentNullException(nameof(userManager));


            _topicService = topicService;
            _userManager = userManager;
        }
        
        [HttpGet]
        public async Task<IActionResult> Index(TopicFilterAndSortModel model, TopicSortState sortState = TopicSortState.DateOfCreationDesc)
        {
            try
            {
                int userId = 0;
                User currentUser = await _userManager.GetUserAsync(User);
                userId = currentUser == null ? 0 : currentUser.Id;
                    
                var topics = _topicService.GetTopicFilterSortPageModel(userId, model, sortState);
                return View(topics);
            }
            catch (ArgumentOutOfRangeException ex)
            {
                ViewBag.BadRequestMessage = ex.Message;
                return View("BadRequest");
            }
            catch (Exception ex)
            {
                return StatusCode(500, ex.Message);
            }
        }

        [Authorize]
        [HttpPost]
        public async Task<IActionResult> CreateTopicAjax(TopicRequestModel model)
        {
            try
            {
                User currentUser = await _userManager.GetUserAsync(User);
                var topicModel = _topicService.CreateTopicAjax(model, currentUser);

                return Ok(topicModel);
            }
            catch (Exception ex)
            {
                return StatusCode(500, ex.Message);
            }
        }

        [AllowAnonymous]
        [HttpPost]
        public IActionResult LikeForTopicAjax(int? topicId)
        {
            if (!topicId.HasValue)
                throw new ArgumentOutOfRangeException(nameof(topicId));
            try
            {
                var likes = _topicService.GetLikeTopic(topicId.Value);
                return Ok(likes);
            }
            catch (Exception ex)
            {
                return StatusCode(500, ex.Message);
            }
        }

        [AllowAnonymous]
        [HttpPost]
        public IActionResult DisLikeForTopicAjax(int? topicId)
        {

            if (!topicId.HasValue)
                throw new ArgumentOutOfRangeException(nameof(topicId));
            try
            {
                var dislikes = _topicService.GetDislikeTopic(topicId.Value);
                return Ok(dislikes);
            }
            catch (Exception ex)
            {
                return StatusCode(500, ex.Message);
            }
        }
    }
}

SecondMVCAppMy/Views/Topic/Index.cshtml
@using Microsoft.AspNetCore.Identity
@using SecondMVCAppMy.DAL.Entities
@model SecondMVCAppMy.Models.Topics.TopicFilterAndSortModel
@inject SignInManager<User> SignInManager
@inject UserManager<User> UserManager

@{
    ViewData["Title"] = "Index";
}


<h1>Index</h1>

<div class="row">
    <div class="col-md-4">
        <form asp-action="Index" method="get">
            <div asp-validation-summary="ModelOnly" class="text-danger"></div>
            <input type="hidden" asp-for="Page" value="@Model.Page" />
            <div class="form-group">
                <label asp-for="SearchKey" class="control-label"></label>
                <input asp-for="SearchKey" class="form-control" value="@Model.SearchKey" />
                <span asp-validation-for="SearchKey" class="text-danger"></span>
            </div>
            <div class="form-group">
                <label asp-for="Author" class="control-label"></label>
                <input asp-for="Author" class="form-control" value="@Model.Author" />
                <span asp-validation-for="Author" class="text-danger"></span>
            </div>
            <div class="form-group">
                <label asp-for="DateFrom" class="control-label"></label>
                <input asp-for="DateFrom" type="date" class="form-control" value="@Model.DateFrom" />
                <span asp-validation-for="DateFrom" class="text-danger"></span>
            </div>
            <div class="form-group">
                <label asp-for="DateTo" class="control-label"></label>
                <input asp-for="DateTo" type="date" class="form-control" value="@Model.DateTo" />
                <span asp-validation-for="DateTo" class="text-danger"></span>
            </div>
            <div class="form-group">
                <input type="submit" value="Search" class="btn btn-primary" />
            </div>
        </form>
    </div>
</div>

<table id="topicTable" class="table">
    <thead>
        <tr>
            <th>
                <a asp-controller="Topic" asp-action="Index" asp-route-sortState=@Model.DateOfCreationSort
                   asp-route-сurrentPage=@Model.TopicPageModel.PageNumber
                   asp-route-page=@Model.Page
                   asp-route-searchKey=@Model.SearchKey
                   asp-route-author=@Model.Author
                   asp-route-dateFrom=@Model.DateFrom
                   asp-route-dateTo=@Model.DateTo>
                    @Html.DisplayNameFor(model => model.Topics[0].DateOfCreation)
                </a>
            </th>
            <th>
                <a asp-controller="Topic" asp-action="Index" asp-route-sortState=@Model.AuthorSort
                   asp-route-сurrentPage=@Model.TopicPageModel.PageNumber
                   asp-route-page=@Model.Page
                   asp-route-searchKey=@Model.SearchKey
                   asp-route-author=@Model.Author
                   asp-route-dateFrom=@Model.DateFrom
                   asp-route-dateTo=@Model.DateTo>
                    @Html.DisplayNameFor(model => model.Topics[0].Author)
                </a>
            </th>
            <th>
                <a asp-controller="Topic" asp-action="Index" asp-route-sortState=@Model.TopicTitleSort
                   asp-route-сurrentPage=@Model.TopicPageModel.PageNumber
                   asp-route-page=@Model.Page
                   asp-route-searchKey=@Model.SearchKey
                   asp-route-author=@Model.Author
                   asp-route-dateFrom=@Model.DateFrom
                   asp-route-dateTo=@Model.DateTo>
                    @Html.DisplayNameFor(model => model.Topics[0].TopicTitle)
                </a>
            </th>
            <th>
                <a asp-controller="Topic" asp-action="Index" asp-route-sortState=@Model.TopicContentSort
                   asp-route-сurrentPage=@Model.TopicPageModel.PageNumber
                   asp-route-page=@Model.Page
                   asp-route-searchKey=@Model.SearchKey
                   asp-route-author=@Model.Author
                   asp-route-dateFrom=@Model.DateFrom
                   asp-route-dateTo=@Model.DateTo>
                    @Html.DisplayNameFor(model => model.Topics[0].TopicContent)
                </a>
            </th>
            <th>
                @Html.DisplayNameFor(model => model.TopicModel.PostsQty)
            </th>
            <th>
                @if (SignInManager.IsSignedIn(User))
                {
                @Html.DisplayNameFor(model => model.TopicModel.QtyUserPostsInTopic)
                }
                else
                {

                }
            </th>
            <th></th>
        </tr>
    </thead>
    <tbody>
        @foreach (var item in Model.Topics)
        {
        <tr>
            <td>
                @Html.DisplayFor(modelItem => item.DateOfCreation)
            </td>
            <td>
                @Html.DisplayFor(modelItem => item.Author)
            </td>
            <td>
                <a asp-action="Index" asp-controller="PostInTopic" asp-route-topicId="@item.Id">
                    @Html.DisplayFor(modelItem => item.TopicTitle)
                </a>
            </td>
            <td>
                <a asp-action="Index" asp-controller="PostInTopic" asp-route-topicId="@item.Id">
                    @Html.DisplayFor(modelItem => item.TopicContent)
                </a>
            </td>
            <td>
                @Html.DisplayFor(modelItem => item.PostsQty)
            </td>
            <td>
                @if (SignInManager.IsSignedIn(User))
                    {
                @Html.DisplayFor(modelItem => item.QtyUserPostsInTopic)
                    }
                    else
                    {

                    }
            </td>
            <td id="likesCount-@item.Id">
                @Html.DisplayFor(modelItem => item.Likes)
            </td>
            <td>
                <input type="button" value="Лайк" onclick="likeTopic('@item.Id')" />
            </td>
            <td id="disLikesCount-@item.Id">
                @Html.DisplayFor(modelItem => item.Dislikes)
            </td>
            <td>
                <input type="button" value="Дизлайк" onclick="disLikeTopic('@item.Id')" />
            </td>
            <td></td>
        </tr>
        }
    </tbody>
</table>


@if (Model.TopicPageModel.HasPreviousPage)
{
<a asp-action="Index"
   asp-route-name="@Model.Author"
   asp-route-dateFrom="@Model.DateFrom"
   asp-route-dateTo="@Model.DateTo"
   asp-route-sortState="@Model.TopicSortState"
   asp-route-page="@(Model.TopicPageModel.PageNumber - 1)"
   class="btn btn-outline-dark btn">
    <i class="glyphicon glyphicon-chevron-left"></i>
    Prev
</a>
}

<span style="margin: 20px">@Model.TopicPageModel.PageNumber</span>

@if (Model.TopicPageModel.HasNextPage)
{
<a asp-action="Index"
   asp-route-name="@Model.Author"
   asp-route-dateFrom="@Model.DateFrom"
   asp-route-dateTo="@Model.DateTo"
   asp-route-sortState="@Model.TopicSortState"
   asp-route-page="@(Model.TopicPageModel.PageNumber + 1)"
   class="btn btn-outline-dark btn">
    <i class="glyphicon glyphicon-chevron-right"></i>
    Next
</a>
}

<p>

</p>

@if (SignInManager.IsSignedIn(User))
{
    <div>
        <div><input type="button" id="addTopic" class="btn-primary" value="Создать тему" /></div>
        <div id="topicForm" style="display: none">
            <div>
                <p>Заголовок темы:</p>
                <textarea id="topicTitleText" class="form-control"></textarea>
            </div>
            <div>
                <p>Содержание темы:</p>
                <textarea id="topicContentText" class="form-control"></textarea>
            </div>
            <div><input type="button" id="createTopic" class="btn-primary" value="Create" /></div>
        </div>
    </div>
}
else
{

}

<br />
<p>
    <a asp-action="Index">Back to List</a>
</p>


<script>
    function likeTopic(topicId) {
        $.ajax({
            url: '@Url.Action("LikeForTopicAjax", "Topic")',
            method: 'POST',
            data: { 'topicId': topicId },
            error: function(data) {
                console.log(data);
                alert('Error' + data.status + "\n" + data.responseText);
            },
            success: function(data) {
                $('#likesCount-' + topicId).html(data);
            }
        });
    }
    function disLikeTopic(topicId) {
        $.ajax({
            url: '@Url.Action("DisLikeForTopicAjax", "Topic")',
            method: 'POST',
            data: { 'topicId': topicId },
            error: function(data) {
                console.log(data);
                alert('Error' + data.status + "\n" + data.responseText);
            },
            success: function(data) {
                $('#disLikesCount-' + topicId).html(data);
            }
        });
    }
</script>

@section Scripts
{
    <script>

        $('#addTopic').click(function () {
            //$('#topicForm').val('');
            $('#topicForm').show();
            $('#addTopic').hide();
        });

        $('#createTopic').click(function () {

            var topicTitle = $('#topicTitleText').val();
            var topicContent = $('#topicContentText').val();

            $.ajax({
                url: '@Url.Action("CreateTopicAjax", "Topic")',
                method: 'POST',
                data: { 'topicTitle': topicTitle, 'topicContent': topicContent },
                dataType: 'JSON',
                error: function (data) {
                    console.log(data);
                    alert('Error ' + data.status + "\n" + data.responseText);
                },
                success: function (data) {
                    $('#topicForm').hide();
                    $('#addTopic').show();
                    var dateOfCreationCell = "<td>" + data.dateOfCreation + "</td>";
                    var authorCell = "<td>" + data.author + "</td>";
                    var topicTitleCell = "<td>" + data.topicTitle + "</td>";
                    var topicContentCell = "<td>" + data.topicContent + "</td>";
                    var postsQtyCell = "<td>" + data.postsQty + "</td>";
                    var qtyUserPostsInTopicCell = "<td>" + data.qtyUserPostsInTopic + "</td>";
                    var likesCell = "<td>" + data.likes + "</td>";
                    var likeTopicCell = "<td>" + data.likePostInTopic + "</td>";
                    var dislikesCell = "<td>" + data.dislikes + "</td>";
                    var disLikeTopicCell = "<td>" + data.disLikePostInTopic + "</td>";
                    var newRow = "<tr>" + dateOfCreationCell + authorCell + topicTitleCell +
                        topicContentCell + topicContentCell + postsQtyCell + postsQtyCell +
                        qtyUserPostsInTopicCell + likesCell + likeTopicCell + dislikesCell +
                        + disLikeTopicCell + "</tr>";
                    $('#topicTable tbody').prepend(newRow);
                }
            });
        });

    </script>
}